(ns com.oly.static-sites.do-blog.pages.chess.render
  (:require
   [com.oly.static-sites.do-blog.pages.chess.state :refer [white-square black-square]]
   [com.oly.static-sites.do-blog.pages.chess.movement :refer [fetch-selected-piece-moves]]))

(defn calculate-black-white [pos]
  (if (even? (first pos))
    (if (even? (second pos))
      :black :white)
    (if (even? (second pos))
      :white :black)))

(defn draw-square [pos pieces]
  (let [square (calculate-black-white pos)
        piece (first (filter #(= pos (:start-pos %)) pieces))
        selected-piece-moveable (fetch-selected-piece-moves (first (filter :selected pieces)))
        moveable-square (first (filter #(= pos %) selected-piece-moveable))]

    (-> {:text (cond
                 (:selected piece) (:character piece) ;"S "
                 piece (:character piece)
                 moveable-square "O "
                 :else (if (= (calculate-black-white pos) :black)
                         white-square
                         black-square))}
        (assoc :colour (if (= square :black)
                         white-square
                         black-square)
               :class (if (= square :black)
                        "fl bg-white-80 black-80"
                        "fl bg-black-80 white-80")))))

(defn draw-board [pieces]
  (loop [x 1
         y 1
         result []]
    (if (>= x 8)
      (if (>= y 8)
        (conj result (draw-square [x y] pieces))
        (recur 1 (+ 1 y) (conj result (draw-square [x y] pieces))))
      (recur (+ 1 x) y (conj result (draw-square [x y] pieces))))))
